<?php

namespace Mcnd\CLI;

#[\Attribute]
class Command
{
    public function __construct(
        public readonly string $name,
        public string $description,
        public array $options = [],
        public null|Command $parent = null,
        public \Closure|string|null $callback = null,
        public bool $isRoot = false,
    ) {}

    public function pushOption(Option|array $option) : void
    {
        $this->options[] = array_merge($this->options, $option);
    }
}