<?php

namespace Mcnd\CLI\Lib;

enum FormatEnum : string
{
    case Normal = "0";
    case Bold = "1";
    case Dim = "2";
    case Italic = "3";
    case Underlined = "4";
    case Blinking = "5";
    case Reverse = "7";
    case Invisible = "8";

    public static function mapFrom(string $name): ?self
    {
        return [
            'n' => self::Normal,
            'normal' => self::Normal,
            'b' => self::Bold,
            'bold' => self::Bold,
            'd' => self::Dim,
            'dim' => self::Dim,
            'i' => self::Italic,
            'italic' => self::Italic,
            'u' => self::Underlined,
            'underlined' => self::Underlined,
            'blinking' => self::Blinking,
            'reverse' => self::Reverse,
            'invisible' => self::Invisible,
        ][$name] ?? null;
    }

    public function output() : string
    {
        return "\e[{$this->value}m";
    }
}