<?php

namespace Mcnd\CLI\Lib;

class RgbColor
{
    public readonly string $rgb;

    public function __construct(int $red, int $green, int $blue)
    {
        $this->rgb = "$red;$green;$blue";
    }

    public static function mapFrom(string $value) : ? self
    {
        $begin = strpos($value, 'rgb(') + 4;
        $end = strrpos($value, ')');

        $rgb = substr($value, $begin, $end - $begin);

        return new static(...explode(';', $rgb));
    }

    public function output() : string
    {
        return "\033[38;2;{$this->rgb}m";
    }
}