<?php

namespace Mcnd\CLI\Lib;

enum ValueTypeEnum
{
    case NoColors;
    case Ascii16;
    case Ascii256;

    public static function autodetect(string $value) : self
    {
        if ( substr($value, 0, 4) === 'rgb(' ) {
            if (! strstr($value, ')')) {
                throw new \InvalidArgumentException(
                    sprintf("An unclosed parenthesis was found for 'rgb' color %s", $value)
                );
            }

            return self::Ascii256;
        }
        elseif ( ColorEnum::mapFrom($value) !== null || BackgroundColorEnum::mapFrom($value) ) {
            return self::Ascii16;
        }

        return self::NoColors;
    }
}
